/***************************************************************************
    strman.c  -  description
    ------------------------
    begin                : pi lut 11 09:59:54 CET 2000
    copyright            : (C) 2000 by Tomasz Fiszer
    email                : profis@kki.net.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include "defs.h"
#include "struct.h"

void GetArgumentFromString(char *szStrLn, char *szArgv, int iNum, 
			    const char cStringLim, const char *szDelim)
{
    char	*svptr;
    char	*s, 
		szString[1024];
    char	szBuffer[1024];
    int		iNumCnt = iNum;

    // Copy it for separation
    strcpy(szString, szStrLn);

    s = strtok_r(szString, szDelim, &svptr);
    if (s != NULL)
	strcpy(szBuffer, s);
    while (s != 0)
    {
	if (iNumCnt < 0)
	    break;
	if (szBuffer != NULL && szArgv != NULL)
	    strcpy(szArgv, szBuffer);
	*szBuffer = 0;

        s = strtok_r(NULL, szDelim, &svptr);
	if (s != NULL)
	{
	    //if (*s == '\'')
	    if (*s == cStringLim)
	    {
		strcpy(szBuffer, s);
		//while(s[strlen(s)-1] != '\'')
		while(s[strlen(s)-1] != cStringLim)
		{
		    strcat(szBuffer, " ");
		    s = strtok_r(NULL, szDelim, &svptr);
		    if (s != NULL)
		    	strcat(szBuffer, s);
		    if (s == NULL)
		    {
		    	strcat(szBuffer, "\0");
			break;
		    }
		}
	    }
	    else
		if (s != NULL)
		    strcpy(szBuffer, s);
	}
	iNumCnt--;
    }
}

int GetNumArguments(char *szStrLn, 
		    const char cStringLim, const char *szDelim)
{
    char	*svptr;
    char	*s;
    char	szString[4096];
    int		iCnt = 0, ifl = 0;
    
TRACE;
    strcpy(szString, szStrLn);
TRACE;
    s = strtok_r(szString, szDelim, &svptr);
TRACE;
    while (s != 0)
    {
TRACE;
        iCnt++;
        s = strtok_r(NULL, szDelim, &svptr);
TRACE;
	if (s != NULL)
	{
	    //if (*s == '\'')
	    if (*s == cStringLim)
	    {
		ifl = 1;
		//while(s[strlen(s)-1] != '\'')
TRACE;
		while(s[strlen(s)-1] != cStringLim)
		{
TRACE;
		    s = strtok_r(NULL, szDelim, &svptr);
TRACE;
		    if (s == NULL)
			break;
		}
	    }
	}
    }
TRACE;
    return iCnt;
}
